if(!dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil"] = true;
/**
 * @author Caroline (cdaughtr@us.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil");

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil");

/* adjustWidgetContent is used to adjust the content height of the widget
 * using a number which is derived from the following class naming convention: 
 * rtlContentAdjust_<browser>_<number>, for example: class="rtlContentAdjust_IE_64".
 * 
 * In the skin.html's content div, a class should be added following this naming
 * convention if the content requires an alternate adjustment for rtl.  Currently
 * this only affects the IE7 and IE6 browser.
 * 
 * The adjustment is needed because in some cases, the absolute positioning is broken
 * and relative or static positioning is used which in turn causes the new height
 * calculations using widgetBodyPadTop to be wrong.
 * 
 * Note:  Only IE,IE6,IE7 are currently supported
 * 
 * An example is the Glass/Tinted Glass theme which uses rtlContentAdjust_IE_64.
 * 64 is derived from 
 *    the title which includes icon height:19,margin-top:8,margin-bottom:11 = 38
 *    and the content which includes margin-bottom:26
 *    so the adjustment is 38+26=64.
*/

com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustWidgetContent = function(contentDiv,heightNumber,skinMinSize) {
	var adjusted = false;
	if (builderConfig.isBidi) {		
		var className = (contentDiv.className).split(" ");
		for (var i=0; i<className.length; i++) {
			var str = className[i].split("_");
			if (str.length && str.length === 3) {
				if (str[0] == "rtlContentAdjust") {				
					var browser = str[1];
					if ( (browser === "IE" && dojo.isIE) ||
						 (browser === "IE6" && dojo.isIE === 6) ||
						 (browser === "IE7" && dojo.isIE === 7) ||
						 (browser === "IE8" && dojo.isIE === 8) ) {	
						var adjust = parseInt(str[2],10);						
						if (adjust > 0) {							
							contentHeight = heightNumber - adjust;
							if (skinMinSize && (contentHeight+adjust)<=skinMinSize) {
								heightNumber = skinMinSize;
								contentHeight = heightNumber - adjust;
								dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + tid).style.height = heightNumber + "px";
							}
							contentDiv.style.height = contentHeight;
							adjusted = true;
						}
					}
				}
			}
		}	
	}
	return adjusted;
};	

/* 
 * adjustHeightResizer calls adjustWidgetContent without the skinMinSize parameter.
 */
com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustHeightResizer = function(contentDiv,heightNumber) {
	return com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustWidgetContent(contentDiv,heightNumber,0);
};


/* overrideStyle is used to override a style defined in the skin.html
 * using a style and value which is derived from the following class naming convention: 
 * rtlOverride_<browser>_<style>_<value>, for example: class="rtlOverride_IE6_paddingTop_0px".
 * 
 * In the skin.html's div that contains a paddingTop style, a class can be added following 
 * this naming convention if the div requires an alternate style for rtl.  Currently
 * this is only needed in the IE7 and IE6 browser.  
 * 
 * Note:  Only IE,IE6,IE7 and paddingTop is currently supported.
 * 
 * This override is needed because in some cases, the absolute positioning is broken
 * and relative or static positioning is used which in turn requires a change in the layout.
 * 
 * An example is the Glass/Tinted Glass theme which uses rtlOverride_IE6_paddingTop_0px.
*/

com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.overrideStyle = function(div) {
	var override = false;
	if (builderConfig.isBidi) {
		var className = (div.className).split(" ");
		for (var i=0; i<className.length; i++) {
			var str = className[i].split("_");
			if (str.length && str.length === 4) {
				if (str[0] == "rtlOverride") {				
					var browser = str[1];
					if ( (browser === "IE" && dojo.isIE) ||
						 (browser === "IE6" && dojo.isIE === 6) ||
						 (browser === "IE7" && dojo.isIE === 7) ) {	
						var style = str[2];
						if (style === "paddingTop") {
							div.style.paddingTop = str[3];
							override = true;						
						}
					}
				}
			}
		}
	}
	return override;
};


}
