dojo.provide("com.ibm.pb.screen.position");

(function(){
	
	var axes = ["x","y"],
		depth = {
			x: "w",
			y: "h"	
		},
		toArray = function(a) {
			if(!dojo.isArray(a)) {
				a = [a];
			}
			return a;
		},
		isHidden = function(a) {
			return (dojo.style(a, "display") || "").toLowerCase() == "none";
		};
		
	
	
	scrPos = com.ibm.pb.screen.position = {
		findByDirection: function(relNode, nodes, dir, strictAxis) {
			var p = dojo.position(relNode),
				comp = "beforeDelta", axis, deltaList = [], ret = [], node;
			switch(dir) {
				case "left":
					axis = "x";
					break;
				case "right":
					comp = "afterDelta";
					axis = "x";
					break;
				case "up":
					axis = "y";
					break;
				case "down":
				default:
					comp = "afterDelta";
					axis = "y";
			}
			var nPos = null;
			for(var i=0; i<nodes.length; i++) {
				node = nodes[i];
				if(!isHidden(node)) {
					nPos = dojo.position(node);
					deltaList.push({
						pos: nPos,
						delta: scrPos[comp](nPos, p, axis),
						node: node 
					});
				}
			}
			deltaList = deltaList.sort(this._sortByDelta);
			for(var k=deltaList.length-1; k>=0; k--) {
				if(deltaList[k].delta < 0) {
					deltaList.splice(0, k+1);
					break;
				}
				if(!strictAxis || scrPos.inAxis(p, deltaList[k].pos, axis)) {
					ret.unshift(deltaList[k].node);
				}
			}
			return ret;
		},
		inAxis: function(p1, p2, axis) {
			var a = axis === "x" ? "y" : "x";
			return !(
				(p1[a] > (p2[a] + p2[depth[a]])) || 
				((p1[a] + p1[depth[a]]) < p2[a])
				);
		},
		_sortByDelta: function(p1, p2) {
			return p1.delta - p2.delta;
		},
		isContainedIn: function(p1, p2) {
			return (p1.x >= p2.x && (p1.x + p1.w <= p2.x + p2.w))
				&&   (p1.y >= p2.y && (p1.y + p1.h <= p2.y + p2.h));
		},
		contains: function(p1, p2) {
			return (p1.x <= p2.x && (p1.x + p1.w >= p2.x + p2.w))
				&&   (p1.y <= p2.y && (p1.y + p1.h >= p2.y + p2.h));
		},
		beforeDelta: function(p1, p2, axis) {
			return scrPos.afterDelta.call(this, p2, p1, axis);
		},
		afterDelta: function(p1, p2, axis) {
			return p1[axis] - (p2[axis] + p2[depth[axis]]);
		},
		isBefore: function(p1, p2, axis) {
			return scrPos.beforeDelta.call(this, p1, p2, axis) >= 0;
		},
		isAfter: function(p1, p2, axis) {
			return scrPos.afterDelta.call(this, p1, p2, axis) >= 0;
		},
		boundingBox: function(nodes) {
			var b = {x:null,y:null,w:0,h:0};
			nodes = toArray(nodes);
			dojo.forEach(nodes, function(n){
				if(!isHidden(node)) {
					var p = dojo.position(n);
					dojo.forEach(axes, function(a){
						if(p[a] < b[a] || b[a] === null) {
							b[a] = p[a];
						}
						var diff = (p[a] + p[depth[a]]) - (b[a] + b[depth[a]]);
						if(diff > 0) {
							b[depth[a]] += diff;
						}
					});
				}
			});
			return b;
		},
		extreme: function(nodes, axis) {
			nodes = toArray(nodes);
			var b = scrPos.boundingBox(nodes);
			var ret = {low:[],high:[]}, v = 0;
			
		}
	}
})();
