/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogEntryNode");

dojo.require("com.ibm.mashups.enabler.ModifiableMetaData");
dojo.require("com.ibm.mashups.enabler.catalog.CatalogNode");

//<INTERFACE>
/**
 * Interface that represents a catalog entry; used in the CatalogEntryModel
 * 
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.catalog.CatalogEntryNode", [
		com.ibm.mashups.enabler.catalog.CatalogNode,
		com.ibm.mashups.enabler.ModifiableMetaData ], {
	/**
	 * Returns the definition URL of this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the definition url, never <code>null</code>
	 */
	getDefinitionURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the icon URL of this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the icon url, never <code>null</code>
	 */
	getIconURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the preview thumbnail URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the preview thumbnail url, may be <code>null</code>
	 */
	getPreviewThumbnailURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the preview URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the preview url, may be <code>null</code>
	 */
	getPreviewURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the help URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the help url, may be <code>null</code>
	 */
	getHelpURL : function(resolveEndpoints) {
	},

	/**
	 * Sets the definition URL of this catalog entry
	 * @param {String} url definition url to set; must not be <code>null</code>
	 * @type void
	 */
	setDefinitionURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url definition url to set; must not be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetDefinitionURL : function(url) {
	},

	/**
	 * Sets the icon URL of this catalog entry
	 * @param {String} url icon url to set; must not be <code>null</code>
	 * @type void
	 */
	setIconURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url icon url to set; must not be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetIconURL : function(url) {
	},

	/**
	 * Sets the preview thumbnail URL of this catalog entry
	 * @param {String} url preview thumbnail url to set; may be <code>null</code>
	 * @type void
	 */
	setPreviewThumbnailURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url preview thumbnail url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetPreviewThumbnailURL : function(url) {
	},

	/**
	 * Sets the preview URL of this catalog entry
	 * @param {String} url preview url to set; may be <code>null</code>
	 * @type void
	 */
	setPreviewURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url preview url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetPreviewURL : function(url) {
	},

	/**
	 * Sets the help URL of this catalog entry
	 * @param {String} url help url to set; may be <code>null</code>
	 * @type void
	 */
	setHelpURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url help url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetHelpURL : function(url) {
	},

	/**
	 * Returns the short description of this object in the given locale.
	 * @param {String} locale   the locale for which to retrieve the
	 * short description, must not be <code>null</code>.
	 * @return {String} the short description of this node in the given locale. If a
	 * short description is not available in the given locale, this method
	 * will return <code>null</code>. It is up to the invoker of the
	 * method to implement an appropriate fallback mechanism.
	 */
	getShortDescription : function(locale) {
	},

	/**
	 * Sets the short description for the given locale.
	 * @param {String} desc     short description to set; must not be <code>null</code>
	 * @param {String} locale   locale to set the short description for; must not be <code>null</code>
	 * @return {String} the former short description; if none existed, <code>null</code> is returned
	 */
	setShortDescription : function(desc, locale) {
	}
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl");
